#include <windows.h>
#include <lzexpand.h>
#include "..\\plugin.hpp"
#include "..\\fmt.hpp"

#define SZDD         0x44445A53 
#define KWAJ         0x4A41574B


#ifdef __GNUC__
#pragma pack(1)
#endif

struct TLZHeader
{
  int ID;           //="SZDD"=0x44445A53
  char Reserved[5];
  char LastChar;
  DWORD FileSize;
};

struct TDOSLZHeader
{
  int ID;           //="KWAJ"
  char Reserved[10];
  DWORD FileSize;
};

static struct TLZHeader Header;
static char ModuleName[MAX_PATH];
static char ArcName[MAX_PATH];

// ⪫祭 樨 startup-  GCC
#ifdef __GNUC__
#ifdef __cplusplus
extern "C"
#endif
BOOL WINAPI DllMainCRTStartup(HANDLE hDll, DWORD dwReason, LPVOID lpReserved)
{
  return TRUE;
}
#endif

char *PointToName(char *Name)
{
  char *c=Name;
  do
  {
    if(*c=='\\')
      Name=c+1;
  }while(*c++);
  return Name;
}

char *PointToExt(char *Name, char Sym='.')
{
  char *c=PointToName(Name);
  Name+=lstrlen(Name);
  do
  {
    if(*c==Sym)
      Name=c+1;
  }while(*c++);
  return Name;
}

/*void _GetExpandedName(char *FileName)
{
  char *LastChar;
  lstrcpy(FileName, PointToName(ArcName));
  LastChar=FileName+lstrlen(FileName)-1;
  if(*LastChar=='_' && PointToExt(FileName)<LastChar)
    *LastChar=Header.LastChar;
}*/

extern "C" int WINAPI _export Extract(HWND hWnd, HINSTANCE hInstance,
                                      /*LPCSTR*/char *CmdLine, DWORD dummy)
{
  char Name[MAX_PATH];
  OFSTRUCT ArcOfsStruct, FileOfsStruct;
  INT ArcLZHandle, FileLZHandle;
  int Ret=0;

  char *FileName=PointToExt(CmdLine, '|');
  DWORD Temp=*CmdLine=='"';
  //lstrcpyn(Name, CmdLine+Temp, FileName-CmdLine-2*Temp);
  lstrcpy(Name, CmdLine+Temp); //饭  㬥襭 ࠧ஢ 
  Name[FileName-CmdLine-2*Temp-1]=0;

  ArcLZHandle=LZOpenFile(Name, &ArcOfsStruct, OF_READ);
  if(ArcLZHandle/*!=LZERROR_BADINHANDLE && ArcLZHandle!=LZERROR_GLOBALLOC*/>=0)
  {
    //᫨  ନ஢  ,  ᮧ १ 饣
    //䠩, ᫨ ⠪     ஢ ⠫ :(
    Temp=GetCurrentDirectory(sizeof(Name), Name);
    if(Temp && Name[Temp-1]!='\\')
    {
      Name[Temp++]='\\';
      lstrcpy(Name+Temp, FileName);
    }
    else
      lstrcpy(Name, FileName);

    FileLZHandle=LZOpenFile(Name, &FileOfsStruct, OF_WRITE|OF_CREATE);
    if(FileLZHandle/*!=LZERROR_BADINHANDLE && FileLZHandle!=LZERROR_GLOBALLOC*/>=0)
    {
      if(LZCopy(ArcLZHandle, FileLZHandle)<0)
        Ret=-3;
      LZClose(ArcLZHandle);
    }
    else
      Ret=-2;
    LZClose(FileLZHandle);
  }
  else
    Ret=-1;

  return Ret;
}

DWORD WINAPI _export LoadFormatModule(const char *NewModuleName)
{
  GetShortPathName(NewModuleName, ModuleName, sizeof(ModuleName));
  return 0;
}

BOOL WINAPI _export IsArchive(const char *Name, const BYTE *Data, int DataSize)
{
  Header=*((TLZHeader *)Data);
  return Header.ID==SZDD /*|| Header.ID==KWAJ*/; //"SZDD"
}

BOOL WINAPI _export OpenArchive(const char *Name, int *Type)
{
  *Type=0/*SZDD*/;
  lstrcpy(ArcName, Name);
  return TRUE;
}

int WINAPI _export GetArcItem(struct PluginPanelItem *Item,
                              struct ArcItemInfo *Info)
{
  if(*ArcName && GetExpandedName(ArcName, Item->FindData.cFileName)==1)
  {
    char *Name=PointToName(Item->FindData.cFileName);
    lstrcpy(Item->FindData.cFileName, Name);
    //_GetExpandedName(Item->FindData.cFileName);

    if(!Header.LastChar)
    { 
      char *FileName=Item->FindData.cFileName;
      char *ArcExt=PointToExt(ArcName);
      char *FileExt=PointToExt(FileName);
      
      char IniName[MAX_PATH];
      lstrcpy(IniName, ModuleName);
      *((DWORD *)PointToExt(IniName))=0x494E49;

      GetPrivateProfileString("Convert", ArcExt, FileExt, FileExt, MAX_PATH-(FileExt-FileName), IniName);
    }
    
    Item->FindData.nFileSizeLow=Header.FileSize;
    Item->FindData.nFileSizeHigh=0;

    /*WIN32_FILE_ATTRIBUTE_DATA Attr;
    GetFileAttributesEx(ArcName, GetFileExInfoStandard, &Attr);
    Item->FindData.ftLastWriteTime=Attr.ftLastWriteTime;*/
    WIN32_FIND_DATA Attr;
    FindClose(FindFirstFile(ArcName, &Attr));
    Item->FindData.ftLastWriteTime=Attr.ftLastWriteTime;

    *ArcName=0;
    
    return GETARC_SUCCESS;
  }                                                     
  return GETARC_EOF;
}

BOOL WINAPI _export GetFormatName(int Type, char *FormatName, char *DefaultExt)
{
  lstrcpy(FormatName, "COMPRESS");
  lstrcpy(DefaultExt, "??_");
  return !Type;
}

BOOL WINAPI _export GetDefaultCommands(int Type, int Command, char *Dest)
{
  if(Command==1)
    wsprintf(Dest, "rundll32 %s,Extract %%%%A|%%%%f", ModuleName);
  else if(Command==10)
    lstrcpy(Dest, "compress.exe -r %%f");
  else
    return FALSE;
  return !Type;
}
